/*
 *  SerialServer.h
 *  polynomeSerial
 *
 *  Created by Colin Mann on 5/5/10.
 *  Copyright 2010 Mannchester Analog. All rights reserved.
 *
 */
#ifndef _SERIAL_SERVER_H
#define _SERIAL_SERVER_H 1

#define DEVICE_SERIAL			("tty.usbserial-polynome")
#define BAUD_RATE				B115200
#define MESSAGE_SIZE			2

using namespace std;

#include <termios.h>
#include <pthread.h>


class SerialServer{

	public:

		SerialServer();
		SerialServer(string device_name, speed_t baud, size_t messageSize);
		virtual ~SerialServer();
		
		void				startSerialServer(fd_set thisdevice, size_t pSize);
		

		void				setVerbose(bool);
		void				close();

		

		int					writeBytes(unsigned char * buffer, int length);
		int					writeByte(unsigned char byte);
	
	private:
		void				flush(bool flushIn, bool flushOut);
		int					available();
		void			*_theServer(void *arg);
	
	
	private:
	
		typedef struct SerialDeviceContext{
			fd_set fileDescriptor;
			size_t packetSize;
		} SerialDeviceContext;
	
		bool				bVerbose;
		
		int					fd;				//File Descriptor
		struct				termios oldoptions;
		pthread_t			serial_thread;

};

#endif