/*
 *  message.h
 *  polynomeSerial
 *
 *  Created by Colin Mann on 5/8/10.
 *  Copyright 2010 Mannchester Analog. All rights reserved.
 *
 */

#ifndef _POLYNOME_MESSAGE_H
#define _POLYNOME_MESSAGE_H
	
#define OFF (0)
#define ON  (1)
#define off OFF
#define on  ON

//From Device
#define M_KEYDOWN		0x00
#define M_KEYUP			0x10
#define M_AUXIN			0xE0
	
	
#define ANALOGIN		0x20
#define BUTTONDOWN		0x30
#define BUTTONUP		0x40
#define KEYPAD			0x50
#define KEYPADUP		0x60
#define DEBUG			0x70
#define MODE			0xF0		//Lower 4 bits contain the mode - B
	
#define NO_COMMAND		0xFE		//Debugging Commands
#define NO_PARAMETER	0xFF
	
	
//To Device
#define RGBLED			0x60		//0x1X 0xYR 0xGB			--3 byte command
#define ANALOGQUERY		0x00		//0xExxxx					--1 byte command, xxxx is analog port, xxxx = FF, query all
#define M_LEDSTATE		0x20
#define M_LEDON			0x30
#define M_LEDROW1		0x40
#define M_LEDCOL1		0x50
#define M_LEDROW2		0x10
//#define M_LEDCOL2		0x70
#define M_LEDFRAME		0x80
#define M_CLEAR			0x90
#define MONOCOLOR		0xA0
#define M_MODE			0xB0
#define M_ACTPORT		0xC0
#define ALEDOFF			0xD0		//0xDn						--1 byte command, turns off arcade led n
#define ALEDON			0xE0		//0xEn						--1 byte command, turns on arcade led n		

	
	//(Non combined commands, no shared bits between command and value)
#define MODEMENU		0xF0		//0xF0						--1 byte command, switch mode to MENU
#define MODERGB			0xF1		//0xF1						--1 byte command, switch mode to RGB
#define MODEMONMENU		0xF2		//0xF2						--1 byte command, switch mode to MONOMENU
#define MODEMONO		0xF3		//0xF3						--1 byte command, switch mode to MONOME
#define GETMODE			0xF8		//							--1 byte command, queries device for current mode.
#define NIXIESET		0xF9		//0xF9 0x11112222 0x33334444--3 byte command, last two bytes are nixie display value
#define NIXIEDEC		0xFC		//							--1 byte command, 0b1111 11xx , decimal on/off in xx

	
	
#define MENU				0
#define RGB					1
#define MONOME_MENU			2
#define MONOME				3

#ifndef UART_ERRORS
#define UART_ERRORS
#define UART_FRAME_ERROR		0x08              /* Framing Error by UART       */
#define UART_OVERRUN_ERROR		0x04              /* Overrun condition by UART   */
#define UART_BUFFER_OVERFLOW	0x02              /* receive ringbuffer overflow */
#define UART_NO_DATA			0x01              /* no receive data available   */
#endif





#endif